#include "SPMission.h"

class BTest : public SPMission {
public:
	BTest(void)
	{
		b_count = &b_last - &b_first - 1;
		b_array = &b_first + 1;

		f_count = &f_last - &f_first - 1;
		f_array = &f_first + 1;

		h_count = &h_last - &h_first - 1;
		h_array = &h_first + 1;

		i_count = &i_last - &i_first - 1;
		i_array = &i_first + 1;
	}

	void Setup(void);
	void AddObject(Handle h);
	void Execute(void);

	// bools
	bool
		b_first,
		firstFrame,
		missionOver,
		b_last;

	// floats
	float
		f_first,
		timeOut,
		f_last;

	// handles
	Handle
		h_first,
		playerHandle,
		enemyHandle,
		h_last;

	// integers
	int
		i_first,
		enemyCount,
		i_last;
};

DLLBase *BuildMission(void)
{
	return new BTest();
}

void BTest::Setup(void)
{
	// init vars here
	firstFrame = true;
	enemyHandle = 0;
	enemyCount = 0;
	missionOver = false;
}

void BTest::AddObject(Handle h)
{
	// if new object is fury pilot
	if (IsOdf(h, "fspilo")) {
		// send him to the spawn point
		Goto(h, "spawn1");
	}
}

void BTest::Execute(void)
{
	playerHandle = GetPlayerHandle();

	if (firstFrame) {
		firstFrame = false;
		// first frame stuff here
		const int secsPerMin = 60;
		timeOut = GetTime() + (5 * secsPerMin);
	}

	if (!IsAlive(enemyHandle)) {
		// build enemy at spawn point
		enemyHandle = BuildObject("fvsent", 2, "spawn1");
		if (enemyHandle == 0) {
			// probably no spawn point in mission
			Vector pos;
			// just build a center of map
			pos.x = pos.y = pos.z = 0;
			enemyHandle = BuildObject("fvsent", 2, pos);
		}
		Attack(enemyHandle, playerHandle);
	}

	if (!missionOver) {
		// see if the player lived long enough
		if (GetTime() > timeOut) {
			missionOver = true;
			SucceedMission(GetTime() + 1);
		}
	}
}
